zoj 3471 状压DP

http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemId=4257

难度远不及我之前发的...

可是我第一次的思路居然错了,由于dp方程想设计成二维,可是弄错。也没发现原因。,。

改为一维:dp[s]:状态为s的时候,得到的最大能量,当中s第i位为1表示,i已经被撞毁

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <string>
#include <iostream>
#include <cmath>
#include <map>
#include <queue>
using namespace std;

#define ls(rt) rt*2
#define rs(rt) rt*2+1
#define ll long long
#define rep(i,s,e) for(int i=s;i<e;i++)
#define repe(i,s,e) for(int i=s;i<=e;i++)
#define CL(a,b) memset(a,b,sizeof(a))
#define IN(s) freopen(s,"r",stdin)
#define OUT(s) freopen(s,"w",stdout)

const int MAXN = 12;
int n;
int mat[MAXN][MAXN];
int dp[1<<MAXN];
int scnt;

void init()
{
    CL(mat,0);
    CL(dp,0);
}

int main()
{
    //IN("zoj3471.txt");
    int w;
    while(~scanf("%d",&n) && n)
    {
        init();
        for(int i=0;i<n;i++)
            for(int j=0;j<n;j++)
            {
                scanf("%d",&w);
                mat[i][j]=max(mat[i][j],w);
            }
        int S=1<<n;
        int ans=0;
        for(int s=0;s<S;s++)
        {
            for(int i=0;i<n;i++)
            {
                if((s&(1<<i)))continue;//i不在s
                //if(s == (1<<i))dp[s][i]=0;
               // else
                for(int j=0;j<n;j++)
                {
                    if(i == j)continue;
                    if(!(s&(1<<j)) || !mat[i][j])continue;//j在s,但<span style="font-family: Arial, Helvetica, sans-serif;">dp[s^(1<<j)]中j不在s</span>
                    dp[s]=max(dp[s],dp[s^(1<<j)]+mat[i][j]);//用i撞j
                    //ans=max(dp[s][i],ans);
                }
            }

        }
        for(int s=0;s<S;s++)
                ans=max(dp[s],ans);
        printf("%d\n",ans);
    }
    return 0;
}
时间: 2024-10-19 12:36:00

zoj 3471 状压DP的相关文章

Most Powerful(ZOJ 3471状压dp)

题意:n个原子,两两相撞其中一个消失,产生能量,给出任意两原子相撞能产生的能量,求能产生的最大能量. 分析:dp[i]表示情况为i时产生的最大能量 /*#include <map> #include <set> #include <list> #include <cmath> #include <queue> #include <stack> #include <cstdio> #include <vector>

ZOJ 3306 状压dp

转自:http://blog.csdn.net/a497406594/article/details/38442893 Kill the Monsters Time Limit: 7 Seconds Memory Limit: 32768 KB In order to celebrate the 8th anniversary of ZOJ, watashi introduces a strange game to other ZJU ACM team members. The board of

zoj 3675 状压dp

http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemId=4918 昨天的排位,最初我还以为思维题,然后队友说状压DP,直接放弃,赛后看了队友的代码,在搜下网上的,发现队友的代码居然是最短的,膜拜啊~~~~~~~ 思路是队友 A.L.的 dp[s]=min(dp[s],dp[s']+1) 其中s'可以由s通过一次正着剪指甲或者反着剪指甲达到 至于内层循环,0-m,是因为----从剪指甲刀的最后一位看,最后一位从0移动到m,足够所有情况了

Survival(ZOJ 2297状压dp)

题意:有n个怪,已知杀死第i个怪耗费的血和杀死怪恢复的血,和杀死boss耗的血,血量不能超过100,若过程中血小于0,则失败,问 是否能杀死boss(boss最后出现). 分析:就是求杀死n个怪后剩余的最大血量 dp[i]表示杀怪情况为i(0未杀,1已杀)时剩余最大血量,注意血量上限为100,过程中血小于0,则失败即可. #include <map> #include <set> #include <list> #include <cmath> #inclu

Travel(HDU 4284状压dp)

题意:给n个城市m条路的网图,pp在城市1有一定的钱,想游览这n个城市(包括1),到达一个城市要一定的花费,可以在城市工作赚钱,但前提有工作证(得到有一定的花费),没工作证不能在该城市工作,但可以走,一个城市只能工作一次,问pp是否能游览n个城市回到城市1. 分析:这个题想到杀怪(Survival(ZOJ 2297状压dp) 那个题,也是钱如果小于0就挂了,最后求剩余的最大钱数,先求出最短路和 Hie with the Pie(POJ 3311状压dp) 送披萨那个题相似. #include <

ZOJ 3471 Most Powerful 状压DP

水题,一维的DP,表示还剩哪些atom的时候能获得的最大能量 #include <cstdio> #include <cstring> #include <iostream> #include <map> #include <set> #include <vector> #include <string> #include <queue> #include <deque> #include <

状压DP [ZOJ 3471] Most Powerful

Most Powerful Time Limit: 2 Seconds      Memory Limit: 65536 KB Recently, researchers on Mars have discovered N powerful atoms. All of them are different. These atoms have some properties. When two of these atoms collide, one of them disappears and a

ZOJ 3471 Most Powerful(状压DP)

Recently, researchers on Mars have discovered N powerful atoms. All of them are different. These atoms have some properties. When two of these atoms collide, one of them disappears and a lot of power is produced. Researchers know the way every two at

ZOJ 3471 Most Powerful(状压DP)

Description Recently, researchers on Mars have discovered N powerful atoms. All of them are different. These atoms have some properties. When two of these atoms collide, one of them disappears and a lot of power is produced. Researchers know the way